include ht48e30.inc

NUM_CSTIMERS	equ 5
NUM_SECTIMERS	equ 5

clockrate equ 4000000   	      		;define clock rate here
prescaler equ 256							; and prescaler (configure below !)
TMRCONSTANT	equ	256-(clockrate/(prescaler*100))	; 10ms

		public _init_softtimers,_CS_TIMERS,_SEC_TIMERS

stvars	.section 'data'
c1s		db ?
_CS_TIMERS	db NUM_CSTIMERS dup(?)
_SEC_TIMERS	db NUM_SECTIMERS dup(?)
tmp		db ?
softstack	db 3 dup(?)

int		.section at 8 'code'

		jmp T0HND

stc		.section 'code'

; disable interrupts before calling (T0HND also uses tmp)
_init_softtimers:
		mov A,100							; 100x10ms = 1s
		mov c1s,A
		mov A,NUM_CSTIMERS					; for every timer
		mov tmp,A
		mov A,OFFSET _CS_TIMERS				; indirect 
		mov MP0,A
isl1:	clr IAR0							; clear
		inc MP0								; next
		sdz tmp
		jmp isl1							; loop
		mov A,NUM_SECTIMERS
		mov tmp,A
		mov A,OFFSET _SEC_TIMERS
		mov MP0,A
isl2:	clr IAR0
		inc MP0
		sdz tmp
		jmp isl2
		mov A,TMRCONSTANT				; divide to get 10ms
		mov TMR,A
		mov A,10010111b					; timer, prescaler=256
		mov TMRC,A	
		set INTC.2						; habilita int del timer
		ret



T0HND:	mov softstack,A				; salva A
		mov A,STATUS
		mov softstack[1],A			; salva STATUS
		mov A,MP0
		mov softstack[2],A			; salva MP0

		mov A,NUM_CSTIMERS			; for every timer
		mov tmp,A
		mov A,OFFSET _CS_TIMERS		; indirect
		mov MP0,A
t0l1:	sz IAR0						; skip if 0
		dec IAR0					; decrement otherwise
		inc MP0						; next
		sdz tmp
		jmp t0l1					; loop

		dec c1s						; dec 100s counter
		snz Z
		jmp t0l3					; not 0, exit
		mov A,100					; init counter
		mov c1s,A

		mov A,NUM_SECTIMERS			; handle 'second' timers
		mov tmp,A
		mov A,OFFSET _SEC_TIMERS
		mov MP0,A
t0l2:	sz IAR0
		dec IAR0
		inc MP0
		sdz tmp
		jmp t0l2

t0l3:	mov A,softstack[2]
		mov MP0,A					; recupera MP0
		mov A,softstack[1]
		mov STATUS,A				; recupera STATUS
		mov A,softstack				; recupera A
		reti

